// ParallelSort.cpp: определяет точку входа для консольного приложения.
//

#include "stdafx.h"
#include <process.h>
#include <vector>
#include <iostream>
#include <algorithm>
#include <Windows.h>

using namespace std;

// Массив с данными для сортировки
vector<int> inputdata = { 56, 16, 7, 45, 8, 10, 8, 17, 42, 10 };
// Массив для результата
vector<int> result(10);

HANDLE sortCompleted[2];		// Массив дескрипоторов для события

unsigned __stdcall sortThread(void *param)		// функция потока
{
	int id = reinterpret_cast<int>(param);		// Определяем номер потока

	// Первая фаза - нужно отсортировать свою половину данных
	int start = id == 0 ? 0 : inputdata.size() / 2;					// Определяем какую часть сортировать
	int end = id == 0 ? inputdata.size() / 2 : inputdata.size();

	sort(inputdata.begin() + start, inputdata.begin() + end);		// Сортируем, используя библиотечную функцию

	// Синхронизация между потоками
	SetEvent(sortCompleted[id]);								// Сигнализируем о завершении своей части сортировки

	WaitForSingleObject(sortCompleted[1 - id], INFINITE);		// Ожидаем завершения сортировки другим потоком

	// Вторая фаза - слияние

	if (id == 0)	// Первый поток - выбираем минимальные элементы
	{
		int idx1 = 0, idx2 = inputdata.size() / 2;

		for (int idxResult = 0; idxResult < inputdata.size() / 2; ++idxResult)
		{
			if (inputdata[idx1] < inputdata[idx2])
			{
				result[idxResult] = inputdata[idx1];
				++idx1;
			}
			else
			{
				result[idxResult] = inputdata[idx2];
				++idx2;
			}
		}
	}
	else     // Второй поток - выбираем максимальные элементы
	{
		int idx1 = inputdata.size() / 2 - 1, idx2 = inputdata.size() - 1;

		for (int idxResult = inputdata.size() - 1; idxResult >= inputdata.size() / 2; --idxResult)
		{
			if (inputdata[idx1] > inputdata[idx2])
			{
				result[idxResult] = inputdata[idx1];
				--idx1;
			}
			else
			{
				result[idxResult] = inputdata[idx2];
				--idx2;
			}
		}
	}

	return 0;
}


int main()
{
	HANDLE threads[2];

	for (int e = 0; e < 2; ++e)		// Создание событий
	{
		sortCompleted[e] = CreateEvent(NULL, true, false, NULL);
	}

	for (int t = 0; t < 2; ++t)		// Запуск потоков
	{
		threads[t] = reinterpret_cast<HANDLE>(_beginthreadex(NULL, 0, sortThread, reinterpret_cast<void*>(t), 0, NULL));
	}

	WaitForMultipleObjects(2, threads, true, INFINITE); // Ожидание завершения сортировки

	for (int d : inputdata)		// Вывод промежуточных результатов - отсортированы половинки массива
	{
		cout << d << " ";
	}
	cout << endl;

	for (int d : result)		// Вывод окончательного результата сортировки
	{
		cout << d << " ";
	}
	cout << endl;

    return 0;
}